import { CreatePermissionParams, ListPermissionParams, UpdatePermissionParams, ListResponse, WarrantObject, Warrant } from "../types";
import { WarrantRequestOptions } from "../types/WarrantRequestOptions";
export default class Permission implements WarrantObject {
    permissionId: string;
    meta?: {
        [key: string]: any;
    };
    constructor(permissionId: string, meta: {
        [key: string]: any;
    });
    static create(permission?: CreatePermissionParams, options?: WarrantRequestOptions): Promise<Permission>;
    static get(permissionId: string, options?: WarrantRequestOptions): Promise<Permission>;
    static update(permissionId: string, params: UpdatePermissionParams, options?: WarrantRequestOptions): Promise<Permission>;
    static delete(permissionId: string, options?: WarrantRequestOptions): Promise<string>;
    static listPermissions(listParams?: ListPermissionParams, options?: WarrantRequestOptions): Promise<ListResponse<Permission>>;
    static listPermissionsForUser(userId: string, listParams?: ListPermissionParams, options?: WarrantRequestOptions): Promise<ListResponse<Permission>>;
    static assignPermissionToUser(userId: string, permissionId: string, options?: WarrantRequestOptions): Promise<Warrant>;
    static removePermissionFromUser(userId: string, permissionId: string, options?: WarrantRequestOptions): Promise<string>;
    static listPermissionsForRole(roleId: string, listParams?: ListPermissionParams, options?: WarrantRequestOptions): Promise<ListResponse<Permission>>;
    static assignPermissionToRole(roleId: string, permissionId: string, options?: WarrantRequestOptions): Promise<Warrant>;
    static removePermissionFromRole(roleId: string, permissionId: string, options?: WarrantRequestOptions): Promise<string>;
    getObjectType(): string;
    getObjectId(): string;
}
