import { WarrantObject, WarrantObjectLiteral } from "./Object";
import { PolicyContext, Subject } from "./Warrant";
export declare enum CheckOp {
    AllOf = "allOf",
    AnyOf = "anyOf"
}
export interface CheckWarrantParams {
    object: WarrantObject | WarrantObjectLiteral;
    relation: string;
    subject: WarrantObject | Subject;
    context?: PolicyContext;
}
export interface CheckParams extends CheckWarrantParams {
    debug?: boolean;
}
export interface CheckManyParams {
    op?: CheckOp;
    warrants: CheckWarrantParams[];
    debug?: boolean;
}
export interface FeatureCheckParams {
    featureId: string;
    subject: WarrantObject | Subject;
    context?: PolicyContext;
    debug?: boolean;
}
export interface PermissionCheckParams {
    permissionId: string;
    subject: WarrantObject | Subject;
    context?: PolicyContext;
    debug?: boolean;
}
export interface CheckWarrant {
    objectType: string;
    objectId: string;
    relation: string;
    subject: Subject;
    context: PolicyContext;
}
export interface Check {
    op?: CheckOp;
    warrants: CheckWarrant[];
    debug?: boolean;
}
export declare function checkWarrantParamsToCheckWarrant(checkWarrantParams: CheckWarrantParams): CheckWarrant;
